// Test basic unions
// $Id: t3.g,v 1.1 2002/01/28 11:12:53 malekith Exp $

extern_c void print_string(string);
extern_c void print_int(int);

union foo {
	int Int;
	string String;
	*[int, int] Int2;
	*[foo, foo] Foo2;
}

void print_foo(foo x)
{
	switch x {
	case String[s]:
		print_string(s);
	case Int[i]:
		print_int(i);
	case Int2[u, v]:
		print_string("[");
		print_int(u);
		print_string(",");
		print_int(v);
		print_string("]");
	case Foo2[u, v]:
		print_string("(");
		print_foo(u);
		print_foo(v); 
		print_string(")");
	}

	print_string(" ");
}

int main() export_as "main"
{
	print_foo(String["foo"]);
	print_foo(Int[10]);
	print_foo(Int2[10, 20]);
	print_foo(Foo2[Foo2[Int[10], String["bar"]], Int2[20,30]]);
	print_string(".\n");
	return 0;
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: foo 10 [10,20] ((10 bar ) [20,30] ) .
 */
